<?php
if ( ! class_exists( 'DIY_Tutorials_Plugin_Activation_WPElemento_Importer' ) ) {
    /**
     * DIY_Tutorials_Plugin_Activation_WPElemento_Importer initial setup
     *
     * @since 1.6.2
     */

    class DIY_Tutorials_Plugin_Activation_WPElemento_Importer {

        private static $diy_tutorials_instance;
        public $diy_tutorials_action_count;
        public $diy_tutorials_recommended_actions;

        /** Initiator **/
        public static function get_instance() {
          if ( ! isset( self::$diy_tutorials_instance) ) {
            self::$diy_tutorials_instance = new self();
          }
          return self::$diy_tutorials_instance;
        }

        /*  Constructor */
        public function __construct() {

            add_action( 'admin_enqueue_scripts', array( $this, 'enqueue_scripts' ) );

            // ---------- wpelementoimpoter Plugin Activation -------
            add_filter( 'diy_tutorials_recommended_plugins', array($this, 'diy_tutorials_recommended_elemento_importer_plugins_array') );

            $diy_tutorials_actions                   = $this->diy_tutorials_get_recommended_actions();
            $this->diy_tutorials_action_count        = $diy_tutorials_actions['count'];
            $this->diy_tutorials_recommended_actions = $diy_tutorials_actions['actions'];

            add_action( 'wp_ajax_create_pattern_setup_builder', array( $this, 'create_pattern_setup_builder' ) );
        }

        public function diy_tutorials_recommended_elemento_importer_plugins_array($diy_tutorials_plugins){
            $diy_tutorials_plugins[] = array(
                    'name'     => esc_html__('WPElemento Importer', 'diy-tutorials'),
                    'slug'     =>  'wpelemento-importer',
                    'function' => 'WPElemento_Importer_ThemeWhizzie',
                    'desc'     => esc_html__('We highly recommend installing the WPElemento Importer plugin for importing the demo content with Elementor.', 'diy-tutorials'),               
            );
            return $diy_tutorials_plugins;
        }

        public function enqueue_scripts() {
            wp_enqueue_script('updates');      
            wp_register_script( 'diy-tutorials-plugin-activation-script', esc_url(get_template_directory_uri()) . '/includes/getstart/js/plugin-activation.js', array('jquery') );
            wp_localize_script('diy-tutorials-plugin-activation-script', 'diy_tutorials_plugin_activate_plugin',
                array(
                    'installing' => esc_html__('Installing', 'diy-tutorials'),
                    'activating' => esc_html__('Activating', 'diy-tutorials'),
                    'error' => esc_html__('Error', 'diy-tutorials'),
                    'ajax_url' => esc_url(admin_url('admin-ajax.php')),
                    'wpelementoimpoter_admin_url' => esc_url(admin_url('admin.php?page=wpelemento-importer-tgmpa-install-plugins')),
                    'addon_admin_url' => esc_url(admin_url('admin.php?page=wpelementoimporter-wizard'))
                )
            );
            wp_enqueue_script( 'diy-tutorials-plugin-activation-script' );

        }

        // --------- Plugin Actions ---------
        public function diy_tutorials_get_recommended_actions() {

            $diy_tutorials_act_count  = 0;
            $diy_tutorials_actions_todo = get_option( 'recommending_actions', array());

            $diy_tutorials_plugins = $this->diy_tutorials_get_recommended_plugins();

            if ($diy_tutorials_plugins) {
                foreach ($diy_tutorials_plugins as $diy_tutorials_key => $diy_tutorials_plugin) {
                    $diy_tutorials_action = array();
                    if (!isset($diy_tutorials_plugin['slug'])) {
                        continue;
                    }

                    $diy_tutorials_action['id']   = 'install_' . $diy_tutorials_plugin['slug'];
                    $diy_tutorials_action['desc'] = '';
                    if (isset($diy_tutorials_plugin['desc'])) {
                        $diy_tutorials_action['desc'] = $diy_tutorials_plugin['desc'];
                    }

                    $diy_tutorials_action['name'] = '';
                    if (isset($diy_tutorials_plugin['name'])) {
                        $diy_tutorials_action['title'] = $diy_tutorials_plugin['name'];
                    }

                    $diy_tutorials_link_and_is_done  = $this->diy_tutorials_get_plugin_buttion($diy_tutorials_plugin['slug'], $diy_tutorials_plugin['name'], $diy_tutorials_plugin['function']);
                    $diy_tutorials_action['link']    = $diy_tutorials_link_and_is_done['button'];
                    $diy_tutorials_action['is_done'] = $diy_tutorials_link_and_is_done['done'];
                    if (!$diy_tutorials_action['is_done'] && (!isset($diy_tutorials_actions_todo[$diy_tutorials_action['id']]) || !$diy_tutorials_actions_todo[$diy_tutorials_action['id']])) {
                        $diy_tutorials_act_count++;
                    }
                    $diy_tutorials_recommended_actions[] = $diy_tutorials_action;
                    $diy_tutorials_actions_todo[]        = array('id' => $diy_tutorials_action['id'], 'watch' => true);
                }
                return array('count' => $diy_tutorials_act_count, 'actions' => $diy_tutorials_recommended_actions);
            }

        }

        public function diy_tutorials_get_recommended_plugins() {

            $diy_tutorials_plugins = apply_filters('diy_tutorials_recommended_plugins', array());
            return $diy_tutorials_plugins;
        }

        public function diy_tutorials_get_plugin_buttion($slug, $name, $function) {
                $diy_tutorials_is_done      = false;
                $diy_tutorials_button_html  = '';
                $diy_tutorials_is_installed = $this->is_plugin_installed($slug);
                $diy_tutorials_plugin_path  = $this->get_plugin_basename_from_slug($slug);
                $diy_tutorials_is_activeted = (class_exists($function)) ? true : false;
                if (!$diy_tutorials_is_installed) {
                    $diy_tutorials_plugin_install_url = add_query_arg(
                        array(
                            'action' => 'install-plugin',
                            'plugin' => $slug,
                        ),
                        self_admin_url('update.php')
                    );
                    $diy_tutorials_plugin_install_url = wp_nonce_url($diy_tutorials_plugin_install_url, 'install-plugin_' . esc_attr($slug));
                    $diy_tutorials_button_html        = sprintf('<a class="diy-tutorials-plugin-install install-now button-secondary button" data-slug="%1$s" href="%2$s" aria-label="%3$s" data-name="%4$s">%5$s</a>',
                        esc_attr($slug),
                        esc_url($diy_tutorials_plugin_install_url),
                        sprintf(esc_html__('Install %s Now', 'diy-tutorials'), esc_html($name)),
                        esc_html($name),
                        esc_html__('Install & Activate', 'diy-tutorials')
                    );
                } elseif ($diy_tutorials_is_installed && !$diy_tutorials_is_activeted) {

                    $diy_tutorials_plugin_activate_link = add_query_arg(
                        array(
                            'action'        => 'activate',
                            'plugin'        => rawurlencode($diy_tutorials_plugin_path),
                            'plugin_status' => 'all',
                            'paged'         => '1',
                            '_wpnonce'      => wp_create_nonce('activate-plugin_' . $diy_tutorials_plugin_path),
                        ), self_admin_url('plugins.php')
                    );

                    $diy_tutorials_button_html = sprintf('<a class="diy-tutorials-plugin-activate activate-now button-primary button" data-slug="%1$s" href="%2$s" aria-label="%3$s" data-name="%4$s">%5$s</a>',
                        esc_attr($slug),
                        esc_url($diy_tutorials_plugin_activate_link),
                        sprintf(esc_html__('Activate %s Now', 'diy-tutorials'), esc_html($name)),
                        esc_html($name),
                        esc_html__('Activate', 'diy-tutorials')
                    );
                } elseif ($diy_tutorials_is_activeted) {
                    $diy_tutorials_button_html = sprintf('<div class="action-link button disabled"><span class="dashicons dashicons-yes"></span> %s</div>', esc_html__('Active', 'diy-tutorials'));
                    $diy_tutorials_is_done     = true;
                }

                return array('done' => $diy_tutorials_is_done, 'button' => $diy_tutorials_button_html);
            }
        public function is_plugin_installed($slug) {
            $diy_tutorials_installed_plugins = $this->get_installed_plugins(); // Retrieve a list of all installed plugins (WP cached).
            $diy_tutorials_file_path         = $this->get_plugin_basename_from_slug($slug);
            return (!empty($diy_tutorials_installed_plugins[$diy_tutorials_file_path]));
        }
        public function get_plugin_basename_from_slug($slug) {
            $diy_tutorials_keys = array_keys($this->get_installed_plugins());
            foreach ($diy_tutorials_keys as $diy_tutorials_key) {
                if (preg_match('|^' . $slug . '/|', $diy_tutorials_key)) {
                    return $diy_tutorials_key;
                }
            }
            return $slug;
        }

        public function get_installed_plugins() {

            if (!function_exists('get_plugins')) {
                require_once ABSPATH . 'wp-admin/includes/plugin.php';
            }

            return get_plugins();
        }
        public function create_pattern_setup_builder() {

            $edit_page = admin_url().'post-new.php?post_type=page&create_pattern=true';
            echo json_encode(['page_id'=>'','edit_page_url'=> $edit_page ]);

            exit;
        }

    }
}
/**
 * Kicking this off by calling 'get_instance()' method
 */
DIY_Tutorials_Plugin_Activation_WPElemento_Importer::get_instance();